/*
#    Molecular Dynamics program EGO
#    Copyright (C) 1989  Markus Eichinger, Helmut Grubmueller, and Helmut Heller
#
#    official EGO web site: http://www.lrz.de/~heller/ego/
#
#    Contact the authors here:
#    Dr. Markus Eichinger:   entwicklung@eichinger-net.de
#    Dr. Helmut Grubmueller: hgrubmu@gwdg.de
#    Dr. Helmut Heller:      heller@lrz.de
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#    For the full text of the license, see file LICENSE
#
#########################################################################
*/

/* use the following switch to turn malloc debug on or off */
#define	DEBUGMALLOC	0	/* 0=off or 1=on */


int	ini_mallocdebug(int ininow,int dblevel,int bitpattern,
			int presize,int postsize,int fillbyte,int nodeid);
int	statisticmalloc(char *infostr,int mode);
int	testmalloc(char *infostr, int mode);


#if DEBUGMALLOC 

void*	debugcalloc(int myline,char *myfile,size_t numobj,size_t sobj);
void*	debugrealloc(int myline,char *myfile,void *oldp,size_t newlen);
void*	debugstrdup(int myline,char *myfile,const char *str);
int	debugfree(int myline,char *myfile,void *ptr);


#if !defined(INC_IN_DBMALLOC)

#define calloc(len1,len2)	debugcalloc(__LINE__,__FILE__,(len1),(len2))
#define malloc(len)		debugcalloc(__LINE__,__FILE__,(len),(0))
#define strdup(str)		debugstrdup(__LINE__,__FILE__,(str))
#define free(ptr)		debugfree(__LINE__,__FILE__,(ptr))
#define realloc(ptr,len) 	debugrealloc(__LINE__,__FILE__,(ptr),(len))

#endif
#endif

