/*
#    Molecular Dynamics program EGO
#    Copyright (C) 1989  Markus Eichinger, Helmut Grubmueller, and Helmut Heller
#
#    official EGO web site: http://www.lrz.de/~heller/ego/
#
#    Contact the authors here:
#    Dr. Markus Eichinger:   entwicklung@eichinger-net.de
#    Dr. Helmut Grubmueller: hgrubmu@gwdg.de
#    Dr. Helmut Heller:      heller@lrz.de
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#    For the full text of the license, see file LICENSE
#
#########################################################################
*/

#define NR_OF_ENERGY_ROWS	22
#define NR_OF_PRESSURE_ROWS	56
#define NR_OF_VIRIAL_PRESSURE_ROWS 60
#define NR_OF_COMMENT_LINES	4

void	initialize_restart(void);
void	initialize_analyze(void);

void 	close_output_file(LOAD_MSG_ALL_NODE *global_data,int file_count);

void trick_cur_atoms_insortbuf(int nr_atoms);

void writeout_coordinates(	LOAD_MSG_ALL_NODE *global_data,
				double time_step,	
				int file_count,
				char *version_string );
			
void writeout_energy(	ENERGY_INFO *energy,
			double temperature,double temperature_h2o,double temperature_protein,
			double time_user,double time_real,
			LOAD_MSG_ALL_NODE *global_data,
			double time_step);
		
void	restart(int restart_level,
		int next_step,
		int next_file,
		double time_step,
		LOAD_MSG_ALL_NODE *global_data,
		ENERGY_INFO *energy);

int	writeout_myforces(	LOAD_MSG_ALL_NODE *global_data,
				STRUCT_FORCES *my_force);

void	sort_to_analybuffer(int new_clustering,TRAVELLING_COORDINATES *coords,
                            LOAD_MSG_ALL_NODE *global_data);


