/*
#    Molecular Dynamics program EGO
#    Copyright (C) 1989  Markus Eichinger, Helmut Grubmueller, and Helmut Heller
#
#    official EGO web site: http://www.lrz.de/~heller/ego/
#
#    Contact the authors here:
#    Dr. Markus Eichinger:   entwicklung@eichinger-net.de
#    Dr. Helmut Grubmueller: hgrubmu@gwdg.de
#    Dr. Helmut Heller:      heller@lrz.de
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#    For the full text of the license, see file LICENSE
#
#########################################################################
*/

void set_working_flags(	LOAD_MSG_ALL_NODE *global_data,
			int *do_analyze,
			int *restart_level,
			int *miss_first,
			int *coords_are_coming);
int sort_to_myforces(int atom_id,STRUCT_FORCE_INFO *finfo,double *force);
int set_communication_effort(int for_coords,int for_branches);
int get_communication_effort(int *for_coords,int *for_branches);

int  pk_CLUSTER_DATA(LOAD_MSG_ONE_NODE *msg);
int upk_CLUSTER_DATA(LOAD_MSG_ONE_NODE *msg,int *alloc_per_level);

int pk_LOAD_MSG_ONE_NODE(LOAD_MSG_ONE_NODE *msg);
int pk_LOAD_MSG_ALL_NODE(LOAD_MSG_ALL_NODE *msg);

int pk_ALL_NODE_UPDATE(LOAD_MSG_ALL_NODE *msg);
int pk_LOAD_MSG_ONE_NODE(LOAD_MSG_ONE_NODE *msg);
int pk_LOAD_MSG_ALL_NODE(LOAD_MSG_ALL_NODE *msg);

int upk_ALL_NODE_UPDATE(LOAD_MSG_ALL_NODE *msg);
int upk_LOAD_MSG_ONE_NODE(LOAD_MSG_ONE_NODE *msg);
int upk_LOAD_MSG_ALL_NODE(LOAD_MSG_ALL_NODE *msg);

int  pk_TRAVELLING_BRANCHES(TRAVELLING_BRANCHES *p);
int upk_TRAVELLING_BRANCHES(TRAVELLING_BRANCHES *p);

int  pk_ENERGY_INFO(ENERGY_INFO *p,int no_nodes);
int upk_ENERGY_INFO(ENERGY_INFO *p,int no_nodes);

int  pk_POSITIONS_INFO(LOAD_MSG_ALL_NODE *msg);
int upk_POSITIONS_INFO(LOAD_MSG_ALL_NODE *msg);

int  pk_FORCE_INFO(int my_number,LOAD_MSG_ONE_NODE *my_data,LOAD_MSG_ALL_NODE *global_data);
int upk_FORCE_INFO(STRUCT_FORCES *my_force);

int  pk_TRAVELLING_COORDINATES(TRAVELLING_COORDINATES *p);
int upk_TRAVELLING_COORDINATES(TRAVELLING_COORDINATES *p);

int pk_TRAVELLING_PACKETS(TRAVELLING_PACKETS * p);
int upk_TRAVELLING_PACKETS(TRAVELLING_PACKETS * p);

int pk_TRAVELLING_FORCES(TRAVELLING_FORCES * p);
int upk_TRAVELLING_FORCES(TRAVELLING_FORCES * p);

void adjust_info (int *info);

#if(DEBUG_PCK == 1)
#define ERROR_PCK(where,info,xxx,code) \
info = info | xxx; \
if (info!=0) { \
printf("ERROR_PCK: Warning: Packing failed in %s (%d) with %d!\n",where,code,info); \
adjust_info(&info); \
};
#else
#define ERROR_PCK(where,info,xxx,code) \
info = info | xxx; \
adjust_info(&info); 
#endif
