/*
#    Molecular Dynamics program EGO
#    Copyright (C) 1989  Markus Eichinger, Helmut Grubmueller, and Helmut Heller
#
#    official EGO web site: http://www.lrz.de/~heller/ego/
#
#    Contact the authors here:
#    Dr. Markus Eichinger:   entwicklung@eichinger-net.de
#    Dr. Helmut Grubmueller: hgrubmu@gwdg.de
#    Dr. Helmut Heller:      heller@lrz.de
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#    For the full text of the license, see file LICENSE
#
#########################################################################
*/

/************************************************************************/
/*  functions defined in c_lib.c ****************************************/
/************************************************************************/

int read_ctl_file(	char *control_filename,
			LOAD_MSG_ALL_NODE *global_data);

int readin_bondfile(	int nr_of_atoms,
			char *bond_filen,
			int *bond_data,
			int *old2new_map);

int readin_exclfile(	int nr_of_atoms,
			int flag,
			char *excl_filen,
			int **excl_data,
			int *old2new_map,
			int cur_maxc);

int readin_anglefile(	int *size,
			char *angle_filen,
			int **angle_data,
			int *old2new_map);

int readin_dihefile(	int *size,
			char *dihe_filen,
			int **dihe_data,
			int *old2new_map);

int read_restart_file(		char *filename,
				int nr_of_atoms,
				int *file_count,
				STRUCT_ATOMDATA *atom_data,
				LOAD_MSG_ALL_NODE *global_data);
			
void reset_force_buffer(STRUCT_FORCES *my_force,
			LOAD_MSG_ALL_NODE *global_data);

int read_flood_file(	char *fname,
			LOAD_MSG_ALL_NODE *global_data);

int read_boundary_file( char *fname,
			LOAD_MSG_ALL_NODE *global_data);

int read_sbound_file(	char *fname,
			LOAD_MSG_ALL_NODE *global_data);

int read_ctl_file_free_format_sec(	int nr_of_atoms,
			char *fname,
			STRUCT_ATOMDATA *atom_data,
			int *atom_sele_flag1,
			LOAD_MSG_ALL_NODE *global_data,
			STRUCT_FORCES *my_force);

void ini_my_forces (STRUCT_FORCES *my_force,LOAD_MSG_ALL_NODE *global_data);
void free_my_forces(STRUCT_FORCES *my_force,LOAD_MSG_ALL_NODE *global_data);

