/*
#    Molecular Dynamics program EGO
#    Copyright (C) 1989  Markus Eichinger, Helmut Grubmueller, and Helmut Heller
#
#    official EGO web site: http://www.lrz.de/~heller/ego/
#
#    Contact the authors here:
#    Dr. Markus Eichinger:   entwicklung@eichinger-net.de
#    Dr. Helmut Grubmueller: hgrubmu@gwdg.de
#    Dr. Helmut Heller:      heller@lrz.de
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#    For the full text of the license, see file LICENSE
#
#########################################################################
*/

#define INTEGRATE3(ko_old,ko_new,F_h_new)\
ko_brand_new = ko_new + ((((1.0-g)*(ko_new-ko_old))-(F_h_new[i]*c))*alpha); \
ko_old=ko_new; \
ko_new=ko_brand_new; 

#define INTEGRATE4(velocity,ko_new,F_h_new)\
ko_brand_new = (ko_new+(velocity*global_data->time_step))-(F_h_new[i]*c); \
velocity=ko_new; \
ko_new=ko_brand_new; 

#define INTEGRATE7(old, new) diff=global_data->fric_coeff*(new-old); \
if (fabs(diff)>global_data->max_move) { \
if (diff>0.0)      new=old+global_data->max_move; \
else if (diff<0.0) new=old-global_data->max_move; \
} else new=old+diff;

void addup_all_forces(	ENERGY_INFO *energy,
		 	LOAD_MSG_ONE_NODE *my_data,
		 	LOAD_MSG_ALL_NODE *global_data,
		 	TRAVELLING_FORCES *my_new_forces);

void do_integrate(	ENERGY_INFO *energy,
			LOAD_MSG_ONE_NODE *my_data,
			LOAD_MSG_ALL_NODE *global_data,
			TRAVELLING_FORCES *my_new_forces,
			double *Gamma,
			int my_number);

int do_newrottranscor_part1(int my_number,
			ENERGY_INFO *local_energy,	
			LOAD_MSG_ONE_NODE *my_data,
			LOAD_MSG_ALL_NODE *global_data,
			TRAVELLING_PACKETS *packet);

int
do_newrottranscor_part2(int my_number,
			ENERGY_INFO *local_energy,	
			LOAD_MSG_ONE_NODE *my_data,
			LOAD_MSG_ALL_NODE *global_data,
			TRAVELLING_PACKETS *packet,
			TRAVELLING_FORCES *my_new_forces);
