/*
#    Molecular Dynamics program EGO
#    Copyright (C) 1989  Markus Eichinger, Helmut Grubmueller, and Helmut Heller
#
#    official EGO web site: http://www.lrz.de/~heller/ego/
#
#    Contact the authors here:
#    Dr. Markus Eichinger:   entwicklung@eichinger-net.de
#    Dr. Helmut Grubmueller: hgrubmu@gwdg.de
#    Dr. Helmut Heller:      heller@lrz.de
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#    For the full text of the license, see file LICENSE
#
#########################################################################
*/

void   zero_forces(TRAVELLING_FORCES *forces);

void   rescale(	double scale,
		LOAD_MSG_ALL_NODE *global_data,
		LOAD_MSG_ONE_NODE *my_data);

void   add_to_new_forces(	TRAVELLING_FORCES *forces,
				LOAD_MSG_ONE_NODE *my_data,
				TRAVELLING_FORCES *my_new_forces,
				int my_number);

void   init_for_each_step(	ENERGY_INFO *energy,
				ENERGY_INFO *estm_local_energy,
				ENERGY_INFO *dummy_energy,
				LOAD_MSG_ALL_NODE *global_data,
				LOAD_MSG_ONE_NODE *my_data,
				TRAVELLING_FORCES *my_new_forces,
				TRAVELLING_FORCES *my_exact_LRforces,
				int my_number,
				TRAVELLING_PACKETS *packet,
				int *node_status);

void   reinit_node(	LOAD_MSG_ALL_NODE *global_data,
			LOAD_MSG_ONE_NODE *my_data,
			TRAVELLING_FORCES *my_new_forces,
			TRAVELLING_FORCES *my_exact_LRforces,
			int my_number,
			double *rnd_force_std_deviation,
			double *Gamma,
			TRAVELLING_PACKETS *packet);

void   init_node(	LOAD_MSG_ALL_NODE *global_data,
			LOAD_MSG_ONE_NODE *my_data,
			TRAVELLING_FORCES *my_new_forces,
			TRAVELLING_FORCES *my_exact_LRforces,
			int my_number,
			double **rnd_force_std_deviation,
			double **Gamma,
			TRAVELLING_PACKETS *packet,
			EXT_3_ATOM **ext_angle,
			EXT_4_ATOM **ext_dihe,
			EXT_4_ATOM **ext_impr);
