/*
#    Molecular Dynamics program EGO
#    Copyright (C) 1989  Markus Eichinger, Helmut Grubmueller, and Helmut Heller
#
#    official EGO web site: http://www.lrz.de/~heller/ego/
#
#    Contact the authors here:
#    Dr. Markus Eichinger:   entwicklung@eichinger-net.de
#    Dr. Helmut Grubmueller: hgrubmu@gwdg.de
#    Dr. Helmut Heller:      heller@lrz.de
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#    For the full text of the license, see file LICENSE
#
#########################################################################
*/


double angle_energy (	int angle_ptr,
			int *angle_Nr1,
			int *angle_Nr2,
			int *angle_Nr3,
			int *angle_index,
			int *forceout_atom,
			int *atom_id,
			double *x_new,
			double *y_new,
			double *z_new,
			double *theta0,
			double *k_angle,
			double *ubk,
			double *ubd,
			char is_internal,
			double *force_angle,
			int my_first_atom,
			int my_number,
			EXT_3_ATOM *ext_angle,
			STRUCT_PICK_BOND *pickangle,
			LOAD_MSG_ONE_NODE *my_data);

double improper_energy(	int impr_ptr,
			int *impr_Nr1,
			int *impr_Nr2,
			int *impr_Nr3,
			int *impr_Nr4,
			int *impr_index,
			int *forceout_atom,
			int *atom_id,
			double *x_new,
			double *y_new,
			double *z_new,
			double *omega0,
			double *k_impr,
			char is_internal,
			double *force_impr,
			int my_first_atom,
			int my_number,
			EXT_4_ATOM *ext_impr,
			STRUCT_PICK_BOND *pickimpr,
			LOAD_MSG_ONE_NODE *my_data);

double dihedral_energy( int dihe_ptr,
			int *dihe_Nr1,
			int *dihe_Nr2,
			int *dihe_Nr3,
			int *dihe_Nr4,
			int *dihe_index,
			int *forceout_atom,
			int *atom_id,
			double *x_new,
			double *y_new,
			double *z_new,
			double *phi0,
			double *k_dihe,
			int *n_dihe,
			char is_internal,
			double *force_dihe,
			int my_first_atom,
			int my_number,
			EXT_4_ATOM *ext_dihe,
			STRUCT_PICK_BOND *pickdihe,
			LOAD_MSG_ONE_NODE *my_data);
