/*
#    Molecular Dynamics program EGO
#    Copyright (C) 1989  Markus Eichinger, Helmut Grubmueller, and Helmut Heller
#
#    official EGO web site: http://www.lrz.de/~heller/ego/
#
#    Contact the authors here:
#    Dr. Markus Eichinger:   entwicklung@eichinger-net.de
#    Dr. Helmut Grubmueller: hgrubmu@gwdg.de
#    Dr. Helmut Heller:      heller@lrz.de
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#    For the full text of the license, see file LICENSE
#
#########################################################################
*/

int     ini_pull(LOAD_MSG_ONE_NODE *my_data,LOAD_MSG_ALL_NODE *global_data,int *atom_sele_flag1,int no_max_atoms); /* bhchange */
int     free_pull(void); /* bhchange */
int     merge_packet_to_buffer_pull( int my_number, 
                        int nr_of_atoms,
                        TRAVELLING_COORDINATES *coord,
                        STRUCT_ATOMDATA *atom_data); /* bhchange */

int
ini_imob_and_pull(	LOAD_MSG_ALL_NODE *global_data,
			STRUCT_ATOMDATA *atom_data);

int
ini_rotation(           LOAD_MSG_ALL_NODE *global_data,
			STRUCT_ATOMDATA *atom_data);

int
calculate_COM_etc(	int my_number,
			ENERGY_INFO *local_energy,	
			LOAD_MSG_ONE_NODE *my_data,
			LOAD_MSG_ALL_NODE *global_data);

void calc_imob_energy(	ENERGY_INFO *energy,
			LOAD_MSG_ALL_NODE *global_data);

void add_imob_forces(	LOAD_MSG_ONE_NODE *my_data,
			LOAD_MSG_ALL_NODE *global_data,
			double *Fx,
			double *Fy,
			double *Fz);

void add_pull_forces(	int my_number,
                        ENERGY_INFO *energy,
			LOAD_MSG_ONE_NODE *my_data,
			LOAD_MSG_ALL_NODE *global_data,
			double *Fx,
			double *Fy,
			double *Fz);

void adopt_pull_frame(  ENERGY_INFO     *energy,
			LOAD_MSG_ALL_NODE *global_data);

void alloc_temporary(   LOAD_MSG_ALL_NODE *global_data);
void make_inv_rot_map(  int my_number,
			LOAD_MSG_ONE_NODE *my_data,
			LOAD_MSG_ALL_NODE *global_data);
void add_rotation_forces(	int my_number,
				ENERGY_INFO *energy,
				LOAD_MSG_ONE_NODE *my_data,
				LOAD_MSG_ALL_NODE *global_data,
				double *Fx,
				double *Fy,
				double *Fz);
double **rotation_matrix(double **mat,double omega);
void matrix_dot_matrix(double **mat1,double **mat2,double **mat3);
void mat_dot_vec(double **matti,double *veci,double *veco);
int     free_rotation(void);
