#!/bin/sh
#*** For demonstration we may print out the       ***
# here we modify the calling sequence: we give the unitree save path as the
# very first param in the ctl.lis file, so we have to save it elsewhere now
# and shift the other params to have them in the usual position again.
savepath=$1
shift
#*** parameters the shellscript has got from EGO  ***
echo "First filenumber:" $1
echo "Last filenumber :" $2
echo "Crdfile to creat:" $3
echo "Output-path     :" $4
echo "Lisfile-path    :" $5
echo "Working-path    :" $6

#******************************************
#*** now lets do some work              ***
#******************************************

cd $4	#*** change to the output-path  ***

#*** envoke the conversion routine ego2crd ***
#*** +$3 envokes a incremental adding of files ***
ego2crd $1 $2 +$3 -l -s4448


do_send_files(){
	ftpexec.lis                                             # do the ftp transfer
        if test ! -s ftpoutput.lis; then
                echo "ftp-Outputfile does not exist !"
                echo "ftp-Outputfile does not exist !" >>ctlfile.lis
		mail $USER < "no ftp-outputfile made."

                exit -1
        fi;

        echo "ftp-transfer completed ! Now checking filesize..."
        echo "ftp-transfer completed ! Now checking filesize..." >>ctlfile.lis
        error_occured=`echo "no"`

        check_fsegotaz=`awk 'BEGIN {i=1}                        # get filesize of first file
                             ($1=="-rw-------")&&(i==1) { print $7 }
                             ($1=="-rw-------") { i++ }' ftpoutput.lis`
        echo "    "$egotazfile " local: "$fsegotaz " Remote:" $check_fsegotaz;
        echo "    "$egotazfile " local: "$fsegotaz " Remote:" $check_fsegotaz >>ctlfile.lis;
        if test $fsegotaz != $check_fsegotaz; then
             error_occured=`echo "yes"`
        fi;
}


#************************** compress files *********************************************
							# Make ego-taz file
	egotazfile=`echo $1"-"$2".taz"`
	echo "Compressing ego-files to "$egotazfile
	echo "Compressing ego-files to "$egotazfile >ctlfile.lis
	gtar -czvf $egotazfile *.ego >>ctlfile.lis
	fsegotaz=`ls -l $egotazfile | awk '{print $4}'`		# save file size ego-taz
        if test ! -s "$egotazfile"; then
                echo "Fatal Error - ego-taz-file "$egotazfile" not written !"
                echo "Fatal Error - ego-taz-file "$egotazfile" not written !">>ctlfile.lis
		exit 1
        fi;

	echo "all files written to local computer"
	echo "all files written to local computer" >>ctlfile.lis

#************ make an executable batch-file (ftpexec.lis) for ftp-transfer *************
								# connect to unitree
	echo 'ftp cd1.lrz-muenchen.de 1021 << EOF_FTP 2>&1 > ftpoutput.lis' >ftpexec.lis
	echo verbose >>ftpexec.lis
	echo cd $savepath >>ftpexec.lis
	echo cd ego >>ftpexec.lis
	echo put $egotazfile >>ftpexec.lis			# put the files to unitree
	echo dir $egotazfile >>ftpexec.lis			# look at files realy written
	echo quit >>ftpexec.lis
	echo EOF_FTP>>ftpexec.lis

	chmod u+x ftpexec.lis

#*************** do and check the ftp-transfer *************************
	echo "making the ftp-transfer (first time)..."
	echo "making the ftp-transfer (first time)..." >>ctlfile.lis

	do_send_files

#********************* react on the transfer-result ******************************************
	if test $error_occured = "yes"; then
		echo "Filesize-Check detected an error !"
		echo "Filesize-Check detected an error !" >>ctlfile.lis
		echo "trying the ftp-transfer (second time)..."
		echo "trying the ftp-transfer (second time)..." >>ctlfile.lis

		do_send_files

		if test $error_occured = "yes"; then
			echo "Second try didn't succeed, sending mail to user"
			echo "Second try didn't succeed, sending mail to user">>ctlfile.lis
			mail $USER < "ftp-Transfer did not succeed."

			exit -1
		fi;
	fi;
#********************** all things ok.... deleting files **********************************
	echo "Filesize-Check ok ! Now deleting files..."
	echo "Filesize-Check ok ! Now deleting files..." >>ctlfile.lis
	rm $egotazfile 
	rm ftpoutput.lis ftpexec.lis

#*** erase all files brutaly *****************
rm *.ego

cd $6	#*** get back to our working path ***

exit 0;	#*** dont forget to return 0 if ***
	#*** all things went OK !	***	
