C***********************************************************************
      SUBROUTINE GetP(Sym,RName,IChem,NAt,XAt,YAt,ZAt,ANam,RNam, 
     @                NPUp,NPLo,PUp,PLo)
C
C compute the average location of an atom type (like P)
C
      IMPLICIT NONE
      INTEGER      IChem,NAt
      CHARACTER*1  Sym
      CHARACTER*4  ANam(*)
      CHARACTER*3  RName,RNam(*)
      REAL         XAt(*),YAt(*),ZAt(*),PUp(3), PLo(3)
      INTEGER      NPUp,NPLo
      INTEGER      I,IChemp
C-----------------------------------------------------------------------
      PUp(1) = 0.0
      PUp(2) = 0.0
      PUp(3) = 0.0
      PLo(1) = 0.0
      PLo(2) = 0.0
      PLo(3) = 0.0
      NPUp = 0
      NPLo = 0
      DO 70 I=1,NAt,1
	IF (RNam(I).EQ.RName) THEN
	  IF (ANam(I)(IChem:IChem).EQ.' ') THEN
	    IChemp = IChem + 1
	  ELSE
	    IChemp = IChem
	  ENDIF	  
	  IF (ANam(I)(IChemp:IChemp).EQ.Sym) THEN
	    IF (YAt(I).GT.0.0) THEN
	      NPUp = NPUp+1
	      PUp(1) = PUp(1)+XAt(I)
	      PUp(2) = PUp(2)+YAt(I)
	      PUp(3) = PUp(3)+ZAt(I)
	    ELSE
	      NPLo = NPLo+1
	      PLo(1) = PLo(1)+XAt(I)
	      PLo(2) = PLo(2)+YAt(I)
	      PLo(3) = PLo(3)+ZAt(I)
	    ENDIF
	  ENDIF
	ENDIF
  70  CONTINUE
      IF (NPUp.GT.0) THEN
	PUp(1) = PUp(1)/REAL(NPUp)
	PUp(2) = PUp(2)/REAL(NPUp)
	PUp(3) = PUp(3)/REAL(NPUp)
      ENDIF
      IF (NPLo.GT.0) THEN
	PLo(1) = PLo(1)/REAL(NPLo)
	PLo(2) = PLo(2)/REAL(NPLo)
	PLo(3) = PLo(3)/REAL(NPLo)
      ENDIF
      RETURN
      END
C
C
C***********************************************************************
      FUNCTION InSide(X,Y,Z,Fr,axes)
      IMPLICIT NONE
      LOGICAL   InSide
      REAL      X,Y,Z,Fr(6)
      CHARACTER axes*(*)
C-----------------------------------------------------------------------
      InSide = .TRUE.
C
      IF ((INDEX(axes,'x').GE.1).OR.(INDEX(axes,'X').GE.1)) THEN
        IF ((X.LT.Fr(1)).OR.(X.GT.Fr(4))) InSide = .FALSE.
      ENDIF
C 
      IF ((INDEX(axes,'y').GE.1).OR.(INDEX(axes,'Y').GE.1)) THEN
        IF ((Y.LT.Fr(2)).OR.(Y.GT.Fr(5))) InSide = .FALSE.
      ENDIF
C 
      IF ((INDEX(axes,'z').GE.1).OR.(INDEX(axes,'Z').GE.1)) THEN
        IF ((Z.LT.Fr(3)).OR.(Z.GT.Fr(6))) InSide = .FALSE.
      ENDIF
C 
      RETURN
      END
C
C
