#!/bin/csh
# ----------------------------------------------------------------
# LoadLeveler commands must start with "# @".  Other lines
# starting with "#" are comments.
#
# To complete this job command file, you will need to set the
# following LoadLeveler keywords:  initialdir, error, output,
# input, class, min_processors, notify_user. 
#
# @ environment = "LL_JOB=TRUE"
# @ initialdir =  /stmp/stmp91/a283212/47a
# @ notify_user = heller@lrz.de
# @ error       = ego8.$(Cluster).err
# @ output      = ego8.$(Cluster).out
## @ input      = /dev/null
# @ job_type = parallel
# @ job_name = EGO
# @ requirements =  (Adapter == "hps_user")
# @ class      = p16_8h
# @ min_processors    = 5 
# @ max_processors    = 9 
# @ notification = always
# @ queue
# --------------------------------------------------------------------
set echo
echo "ego_VIII job starts at"
date
setenv MP_NEWJOB yes
setenv MP_EUILIB us
# We signal our process that time is up soon about 10 minutes before
# try to make a restart file. 
(sleep 27000; kill -USR1 `ps -efd | grep ego.axposf | grep -v grep | awk '{print $2}'`) &
# the time is really up:
(sleep 28000; kill -USR2 `ps -efd | grep ego.axposf | grep -v grep | awk '{print $2}'`) &
# We must use the local EGO with HARMOINC_PATCH=7 to have all boundaries active!
./ego.axposf
./resubmit "llsubmit mpi8.cmd"
echo "ego8 job done at" 
date
# kill the other sleep process
kill `ps -efd | grep sleep | grep -v grep | awk '{print $2}'`
# last line
