#!/bin/csh
# This program takes ego output files as argument.
# You will get the time-weighted average utilization.
if ($#argv == 0) then
  echo "This program takes ego output files as argument."
  echo "You will get the time-weighted average utilization."
  echo "Call: aveutil.awk <ego-file> [<egofile> [...]]"
else
  cat $* | awk '/REMARK Number of Transputers in net is/{trapunum = $8};\
	  /REMARK Time per step is/{s += $6; n += 1; thistime = $6 };\
	  /REMARK Utilization/{util=0; for (i=2; i<=NF; i++) util=util+$i; util=util/trapunum; util=util*thistime; utilization=utilization+util};\
	  END {print "Average execution time per step is ",s/n,"seconds.\n"n," steps were considered.\nAveraged time-weighted utilization is:",utilization/s," %"}' -
endif
# this is the last line