C  
C  added HBOND energy to enr    
      INTEGER    MAXFRE, MAXNLEN
      PARAMETER  (MAXFRE=39000, MAXNLEN=20)
      INTEGER    IUNCRD, IUNENR, EGO, NFILE
      INTEGER    ISTART, NATOM, NFREAT, NSAVC
      INTEGER    FREEAT(MAXFRE)
      DOUBLE PRECISION   DELTA
      REAL       X(MAXFRE), Y(MAXFRE), Z(MAXFRE)
      LOGICAL    QFIRST, ERROR, OK, gerror
      INTEGER    outpos1, outpos2, inpos, charpos
      CHARACTER*80 infile1, outfile1, outfile2
C
C some initialisation
      DO 100 I=1,MAXFRE
	FREEAT(I)=I
	X(I)=0.0
	Y(I)=0.0
	Z(I)=0.0
  100 CONTINUE
      QFIRST=.TRUE.
      gerror = .FALSE.
      OK=.TRUE.
C
C how many files to comp?
C
ccc      write(6,'(A)') ' USER: how many files to read?'
      read(5,*,ERR=55) nfile
ccc      write(6,'(A,I)') 'nfile = ',nfile
      goto 66
55    OK=.FALSE.
      gerror = .TRUE.
66    if (.not. OK) write(6,'(A)') ' %USER-err: in user main'
C
C output and input files ?
C
ccc      write(6,'(A)') ' USER: infile1?'
      read(5,'(A80)') infile1
      inpos = index(infile1,' ')
      infile1(inpos:inpos)='/'
      charpos = index(infile1,' ')
ccc      write(6,'(A)') ' USER: outfile1?'
      read(5,'(A80)') outfile1
      read(5,'(A80)') outfile2
      outpos1 = index(outfile1,' ')
      outpos2= index(outfile2,' ')
      write(6,'(A)') outfile1
      write(6,'(A)') outfile2
      read(5,'(A20)') outfile1(outpos1:outpos1+MAXNLEN)
      outfile2(outpos2:outpos2+MAXNLEN)=
     @                outfile1(outpos1:outpos1+MAXNLEN)
      outpos1 = index(outfile1,' ')
      outpos2= index(outfile2,' ')
      outfile1(outpos1:outpos1+3)='.crd'
      outfile2(outpos2:outpos2+3)='.enr'
C
C open CRD and ENR output coordinate file
C
      CALL ASSFIL(outfile1,IUNCRD,'WRITE','UNFORMATTED',ERROR)
      gerror = gerror .OR. error
      CALL ASSFIL(outfile2,IUNENR,'WRITE','FORMATTED',ERROR)
      gerror = gerror .OR. error
      DO 200 i=1,nfile
      read(5,'(A10)') infile1(charpos:charpos+MAXNLEN)
      inpos = index(infile1,' ')
      infile1(inpos:inpos+3)='.ego'
C
C open EGO input coordinate file
C
      CALL ASSFIL(infile1,EGO,'READ','FORMATTED',ERROR)
      gerror = gerror .OR. error
C
C read EGO coordinates out of a formatted file
C
      CALL READEG(EGO,IUNENR,X,Y,Z,NFREAT,NSAVC,ISTART,DELTA,ERROR)
      gerror = gerror .OR. error
      NATOM=NFREAT
      DELTA = DELTA*1.0E12
C     write(6,'(A,D20.10)') 'timestep =',DELTA
      CALL WRITEC('CORD',NATOM,X,Y,Z,
     1                  NFREAT,FREEAT,ISTART,QFIRST,
     2                  DELTA,NSAVC,NFILE,IUNCRD)
C close EGO input coordinate file
      CALL VCLOSE(EGO,'KEEP',ERROR)
      gerror = gerror .OR. error
  200 CONTINUE
C
C close CRD and ENR output coordinate file
C
      CALL VCLOSE(IUNCRD,'KEEP',ERROR)
      gerror = gerror .OR. error
      CALL VCLOSE(IUNENR,'KEEP',ERROR)
      gerror = gerror .OR. error
      IF (gerror) write(6,'(A)') 'Somewhere an ERROR occured. 
     1Correct and try again!'
      END
C
      SUBROUTINE ASSFIL(NAME,UNIT,ACCESS,FORM,ERR)
C
C Checks whether file NAME already open and then returns the unit
C otherwise it gets a free FORTRAN unit, tries to open the file
C NAME and gets the full filename specification.
C
C ACCESS : 'WRITE', 'READ', 'APPEND'
C FORM : 'FORMATTED', 'UNFORMATTED'
C NAME : <filename>, 'INPUT', 'OUTPUT'
C
C Axel Brunger, 22-SEP-85
C =======================
C
      IMPLICIT NONE
C input/output
      CHARACTER*(*) NAME, ACCESS, FORM
      INTEGER UNIT
      LOGICAL ERR
C local
      INTEGER L, TMAX, TLEN
      PARAMETER (TMAX=132)
      CHARACTER*(TMAX) T
      LOGICAL QOPEN, QFORM, QWRITE
      EXTERNAL TRIM, VINQRE, VOPEN
C begin
C
      ERR=.FALSE.
      L=LEN(NAME)
      CALL TRIM(NAME,L)
C
C inquire about the file
      CALL VINQRE('FILE',NAME,0,0,QOPEN,QFORM,QWRITE,UNIT)
C
C if file is already open do some error checking
      IF (QOPEN) THEN
      ERR=.TRUE.
      IF (FORM.EQ.'FORMATTED'.AND..NOT.QFORM) THEN
      WRITE(6,'(2A)') ' %ASSFIL-ERR: file ',
     & 'already open but not formatted as requested'
      ELSE IF (FORM.EQ.'UNFORMATTED'.AND.QFORM) THEN
      WRITE(6,'(2A)') ' %ASSFIL-ERR: file ',
     & 'already open but not unformatted as requested'
      ELSE IF ((ACCESS.EQ.'WRITE'.OR.ACCESS.EQ.'APPEND').AND..NOT.QWRITE
     1) THEN
      WRITE(6,'(2A)') ' %ASSFIL-ERR: file ',
     & 'already open but not for write access as requested'
      ELSE IF (ACCESS.EQ.'READ'.AND.QWRITE) THEN
      WRITE(6,'(2A)') ' %ASSFIL-ERR: file ',
     & 'already open but not for read access as requested'
      ELSE
      ERR=.FALSE.
      END IF
      ELSE
C
C file not open, get a free FORTRAN unit
      UNIT=0
177   CONTINUE
      UNIT=UNIT+1
cccc      WRITE(6,'("no prob in ass: not open")')
      CALL VINQRE('UNIT',T,TMAX,TLEN,QOPEN,QFORM,QWRITE,UNIT)
      IF(.NOT. (UNIT.GE.99.OR..NOT.QOPEN)) GOTO 177
      IF (QOPEN) THEN
      WRITE(6,'(A)')' %ASSFIL-ERR: no free unit available'
      ERR=.TRUE.
      ELSE
      CALL VOPEN(UNIT,NAME,FORM,ACCESS,ERR)
      IF (ERR) THEN
      WRITE(6,'(2A)') ' %ASSFIL-ERR: error opening file ',NAME(1:L)
      ELSE
C
C get full file name to print message about opening a file
      CALL VINQRE('UNIT',T,TMAX,TLEN,QOPEN,QFORM,QWRITE,UNIT)
      WRITE(6,'(3A)') ' ASSFIL: file ',T(1:TLEN),' opened.'
      END IF
      END IF
      END IF
cccc      IF (ERR) CALL WRNDIE(-1,'ASSFIL','Error accessing file')
      IF (ERR) WRITE(6,'(A)') ' %ASSFIL: Error accessig file'
cccc      WRITE(6,'(I6)') UNIT
      RETURN
      END
C
      SUBROUTINE VINQRE(MODE,NAME,MAXLEN,LENGTH,QOPEN,QFORM,QWRITE,
     &                  UNIT)
C
C file inquiry by file name or FORTRAN unit
C Flag QOPEN indicates whether file or unit is "open".
C Flag QFORM indicates whether file was opened formatted.
C Flag QWRITe indicates whether file was opened write-access.
C For inquiry by unit MAXLEN has to be specified (max length of NAME)
C and LENGTH returns with the length of NAME.
C For inquiry by file the two names INPUT and OUTPUT are reserved
C for the standard input and output channels 5 and 6.
C
C +++++++++++++++++++++++++++++++++++++++
C machine dependent CONVEX/UNIX version
C +++++++++++++++++++++++++++++++++++++++
C
      IMPLICIT NONE
C I/O
C input/output
C*
C*    BEGINNING OF INCLUDE FILE: iochan.fcm
C*
C IOCHAN.FCM
C ==========
C
C holds machine dependent information about FORTRAN units 1...99
C and their associated files
C
C
C list for free FORTRAN units
C see routine FREEUN
      INTEGER MAXUN
      PARAMETER (MAXUN=99)
      INTEGER IFREEU(MAXUN)
C
C for CRAY version:
C common
      CHARACTER*60 COSPDN(MAXUN)
      CHARACTER*8  COSDN(MAXUN)
C
C-COMMON-declarations
      COMMON /IOCHAN/ IFREEU
      COMMON /CIOCHA/ COSPDN, COSDN
      SAVE /IOCHAN/
      SAVE /CIOCHA/
      CHARACTER*(*) MODE, NAME
      INTEGER MAXLEN, LENGTH
      LOGICAL QOPEN, QFORM, QWRITE
C Convex
      logical qexist
      INTEGER UNIT
      EXTERNAL TRIM
C begin
      QOPEN=.TRUE.
      IF (MODE.EQ.'FILE'.AND.NAME.EQ.'INPUT') THEN
      UNIT=5
      ELSE IF (MODE.EQ.'FILE'.AND.NAME.EQ.'OUTPUT') THEN
      UNIT=6
      ELSE IF (MODE.EQ.'FILE') THEN
C Convex
      inquire(file=name,exist=qexist)
      if (qexist) then
      INQUIRE(FILE=NAME,OPENED=QOPEN,NUMBER=UNIT)
      else
        qopen=.false.
        unit=-1
      endif
      ELSE IF (MODE.EQ.'UNIT') THEN
      INQUIRE(UNIT=UNIT,OPENED=QOPEN,NAME=NAME)
      LENGTH=MAXLEN
      CALL TRIM(NAME,LENGTH)
      END IF
C
C if file is open then get QFORM and QWRITE flags
      IF (QOPEN) THEN
      IF ((+1).EQ.(IFREEU(UNIT))) THEN
      QFORM=.TRUE.
      QWRITE=.TRUE.
      ELSE IF ((+10).EQ.(IFREEU(UNIT))) THEN
      QFORM=.TRUE.
      QWRITE=.FALSE.
      ELSE IF ((-1).EQ.(IFREEU(UNIT))) THEN
      QFORM=.FALSE.
      QWRITE=.TRUE.
      ELSE IF ((-10).EQ.(IFREEU(UNIT))) THEN
      QFORM=.FALSE.
      QWRITE=.FALSE.
      END IF
      END IF
      RETURN
      END
C
      SUBROUTINE VCLOSE(UNIT,DISPOS,ERR)
C
C closes a file/unit with disposition DISPOS and sets the
C corresponding IFREEU element to zero.
C
C DONT CLOSE UNIT 5 OR 6 !!
C
C +++++++++++++++++++++++++++++++++++++++
C machine dependent CONVEX/UNIX version
C +++++++++++++++++++++++++++++++++++++++
C
C By Axel Brunger, 21-APR-85
C
      IMPLICIT NONE
C I/O
C*
C*    BEGINNING OF INCLUDE FILE: iochan.fcm
C*
C IOCHAN.FCM
C ==========
C
C holds machine dependent information about FORTRAN units 1...99
C and their associated files
C
C
C list for free FORTRAN units
C see routine FREEUN
      INTEGER MAXUN
      PARAMETER (MAXUN=99)
      INTEGER IFREEU(MAXUN)
C
C for CRAY version:
C common
      CHARACTER*60 COSPDN(MAXUN)
      CHARACTER*8  COSDN(MAXUN)
C
C-COMMON-declarations
      COMMON /IOCHAN/ IFREEU
      COMMON /CIOCHA/ COSPDN, COSDN
      SAVE /IOCHAN/
      SAVE /CIOCHA/
      INTEGER UNIT
      CHARACTER*(*) DISPOS
      LOGICAL ERR
C begin
      ERR=.FALSE.
      IF (UNIT.NE.6.AND.UNIT.NE.5) THEN
CC      CLOSE(UNIT=UNIT,STATUS=DISPOS,ERR=9999)
      CLOSE(UNIT=UNIT,ERR=9999)
      WRITE(6,'(A)') ' VCLOSE: closed'
      IFREEU(UNIT)=0
      END IF
      GOTO 8888
9999  CONTINUE
      WRITE(6,'(A)') ' %VCLOSE-ERR: error during close '
      ERR=.TRUE.
8888  CONTINUE
      RETURN
      END
C
      SUBROUTINE VOPEN(UNIT,FILE,FORM,ACCESS,ERR)
C
C Opens a file.
C
C +++++++++++++++++++++++++++++++++++++++
C machine dependent CONVEX/UNIX version
C +++++++++++++++++++++++++++++++++++++++
C
C Axel Brunger, 30-APR-85
C =======================
C modified (create "version numbers" on CONVEX): Michael Nilges 21-MAY-87
C
      IMPLICIT NONE
C input/output    
C*
C*    BEGINNING OF INCLUDE FILE: iochan.fcm
C*
C IOCHAN.FCM
C ==========
C
C holds machine dependent information about FORTRAN units 1...99
C and their associated files
C
C
C list for free FORTRAN units
C see routine FREEUN
      INTEGER MAXUN
      PARAMETER (MAXUN=99)
      INTEGER IFREEU(MAXUN)
C
C for CRAY version:
C common
      CHARACTER*60 COSPDN(MAXUN)
      CHARACTER*8  COSDN(MAXUN)
C
C-COMMON-declarations
      COMMON /IOCHAN/ IFREEU
      COMMON /CIOCHA/ COSPDN, COSDN
      SAVE /IOCHAN/
      SAVE /CIOCHA/
      INTEGER UNIT
      CHARACTER*(*) FILE, FORM, ACCESS
      CHARACTER*132  LSTFIL
      LOGICAL ERR
C local
      INTEGER I
      LOGICAL EXISTS
      EXTERNAL NEXTVERS
C begin
      ERR=.FALSE.
      IF (FILE.EQ.'$$INITIAL$$') THEN
C---------------------------------------------------------------
C special section for initialization
C open standard input (channel 5) shared and readonly
CC      OPEN(FORM='FORMATTED',STATUS='OLD',ACCESS='SEQUENTIAL',
CC     &     UNIT=5)
C
C open standard output (channel 6)
CC      OPEN(FORM='FORMATTED',STATUS='NEW',ACCESS='SEQUENTIAL',
CC     &     UNIT=6)
C
C Initialize list of free FORTRAN units.
C It is assumed that system input is assigned to unit 5
C and system output is assigned to unit 6 and all other
C units are deassigned.
      DO 100 I=1,MAXUN
      IFREEU(I)=0
  100 CONTINUE
      IFREEU(5)=10
      IFREEU(6)=1
      ELSE
      IF (FORM.NE.'FORMATTED'.AND.FORM.NE.'UNFORMATTED') THEN
      WRITE(6,'(3A)')
     & ' %VOPEN-ERR: unknown format qualifier "',FORM,'"'
      ERR=.TRUE.
      ELSE
C---------------------------------------------------------------
C write append access
      IF (ACCESS.EQ.'APPEND') THEN
C     OPEN(FILE=FILE,FORM=FORM,STATUS='OLD',ACCESS='APPEND',ERR=9999,
C    &     UNIT=UNIT)
      WRITE(6,*) 'NOT IMPLEMENTED: APPEND!'
      STOP
C---------------------------------------------------------------
C read access
      ELSE IF (ACCESS.EQ.'READ') THEN
*
*     match write access versioning by checking for existence
*     let first name = last existing name even if it doesn't
*     then loop replacing last existing name till version not found
*
      INQUIRE(FILE=FILE,EXIST=EXISTS)
      LSTFIL = FILE
 200  IF (EXISTS) THEN
        LSTFIL = FILE
        CALL NEXTVERS(FILE)
        INQUIRE(FILE=FILE,EXIST=EXISTS) 
	GOTO 200
      END IF
      OPEN(FILE=LSTFIL,FORM=FORM,STATUS='OLD',ACCESS='SEQUENTIAL',
     &     ERR=9999,UNIT=UNIT)
C---------------------------------------------------------------
C write access
      ELSE IF (ACCESS.EQ.'WRITE') THEN
      INQUIRE(FILE=FILE,EXIST=EXISTS)
  300 IF (EXISTS) THEN
        CALL NEXTVERS(FILE)
        INQUIRE(FILE=FILE,EXIST=EXISTS)
	GOTO 300
      END IF
      OPEN(FILE=FILE,FORM=FORM,STATUS='NEW',ACCESS='SEQUENTIAL',
     &     ERR=9999,UNIT=UNIT)
C---------------------------------------------------------------
      ELSE
      WRITE(6,'(3A)')
     & ' %VOPEN-ERR: unknown access qualilifer "',ACCESS,'"'
      ERR=.TRUE.
      END IF
      GOTO 8888
9999  ERR=.TRUE.
8888  CONTINUE
C
      IF (.NOT.ERR) THEN
C
C put appropriate code in IFREEU array:
C  +10 read formatted
C  +1  write/append formatted
C  -1  write/append unformatted
C  -10 read unformatted
      IF (FORM.EQ.'FORMATTED') THEN
      IFREEU(UNIT)=1
      ELSE
      IFREEU(UNIT)=-1
      END IF
      IF (ACCESS.EQ.'READ') IFREEU(UNIT)=IFREEU(UNIT)*10
      END IF
      END IF
      END IF
      RETURN
      END
C
C
      SUBROUTINE WRITEC(HDR,NATOM,X,Y,Z,
     1                  NFREAT,FREEAT,ISTART,QFIRST,
     2                  DELTA,NSAVC,NSET,UNIT)
C
C Writes a set of coordinates/velocities for a single dynamics step;
C if NFREAT unequal NATOM the output is compressed using FREEAT;
C ISTART should be the number of the first set written on file UNIT;
C if the flag QFIRST is true a new file with a header is created;
C NSAVC is the coordinate set writing period;
C NSET is the number of expected sets on file UNIT.
C
C By Axel Brunger, Cambridge, 17-AUG-83
C =====================================
C
      IMPLICIT NONE
C input/output
      CHARACTER*4 HDR
      INTEGER NATOM
      REAL    X(*), Y(*), Z(*)
      INTEGER FREEAT(*), NFREAT, ISTART
      LOGICAL QFIRST
      DOUBLE PRECISION    DELTA
      INTEGER NSAVC, NSET
      INTEGER UNIT
C local
      INTEGER I0, I
      PARAMETER (I0=0)
      EXTERNAL WRTIT
C begin
cccc      IF (UNIT.LT.0) CALL WRNDIE(-3,'WRITEV','invalid logical unit')
      IF (UNIT.LT.0) WRITE(6,'(A)') 'invalid logical unit'
      IF (QFIRST) THEN
      WRITE(6,'(3A,I8,A,I5,A)')
     & ' WRITEC: ',HDR,' sets starting from step ',ISTART,
     & ' are written every ',NSAVC,'  steps'
      WRITE(6,'(A,I8,A)') ' WRITEC: where ',NFREAT,' atoms are "free"'
      WRITE(6,'(A,I5,A)') ' WRITEC: total ',NSET,' sets are written'
C
      WRITE(UNIT) HDR,NSET,ISTART,NSAVC,I0,I0,
     1              I0,I0,I0,NATOM-NFREAT,DELTA,
     2              I0,I0,I0,I0,I0,I0,I0,I0,I0
C
C subroutine WRTITL modified to a primitive WRTIT
C
      CALL WRTIT(UNIT,-1)
C
      WRITE(UNIT) NATOM
      IF (NFREAT.NE.NATOM) WRITE(UNIT) (FREEAT(I),I=1,NFREAT)
      END IF
C
C write coordinates in single precision
      IF (QFIRST.OR.NATOM.EQ.NFREAT) THEN
      WRITE (UNIT) (X(I),I=1,NATOM)
      WRITE (UNIT) (Y(I),I=1,NATOM)
      WRITE (UNIT) (Z(I),I=1,NATOM)
      ELSE
      WRITE (UNIT) (X(FREEAT(I)),I=1,NFREAT)
      WRITE (UNIT) (Y(FREEAT(I)),I=1,NFREAT)
      WRITE (UNIT) (Z(FREEAT(I)),I=1,NFREAT)
      END IF
C
      QFIRST=.FALSE.
C
      RETURN
      END
C
C
      SUBROUTINE TRIM(ST,STLEN)
C routine removes trailing blanks and CRs in string ST
C
C Axel Brunger, 10-DEC-83
C =======================
C
      IMPLICIT NONE
C input/output
      CHARACTER*(*) ST
      INTEGER STLEN
C begin
      IF (STLEN.GT.0) THEN
  400 CONTINUE
      IF (STLEN.GE.1.AND.
     @(ST(STLEN:STLEN).EQ.' ' .OR. (ST(STLEN:STLEN).EQ.CHAR(13)))) THEN
        STLEN=STLEN-1
        GOTO 400
      END IF
      END IF
      RETURN
      END
C
      SUBROUTINE READEG(EGO,IUNENR,X,Y,Z,NATOM,NSAVC,ISTART,DELTA,ERROR)
C
C reads coordinates in EGO-format.
C changed version of subroutine CREAD in coorio.s
C Axel Brunger, 19-FEB-84
C =======================
C
C
      IMPLICIT NONE
C input/output
      CHARACTER*1 TAB
      PARAMETER (TAB = CHAR (9))
      REAL      X(*), Y(*), Z(*)
      INTEGER   EGO, IUNENR, NATOM, NSAVC, ISTART
      INTEGER   NLINFO
C use NLINFO=13 if no SBOUND
C use NLINFO=14 if NO flooding is present
C use NLINFO=15 if SBOUND and FLOODING
      PARAMETER     (NLINFO = 15)
C   Number of different energy contributions (including time and step number etc)
      CHARACTER*80  PLINFO(NLINFO)
      CHARACTER*80  DUMMY
C local
      DOUBLE PRECISION  ENERGY(NLINFO), DOUBLE, DELTA
      INTEGER    IATOM, I, J, PLEN, DLEN, BEGIN, INT, NSTEP
C	Added S. Crouzy Jan. 3 1995
      INTEGER    NSAVE
C      NUMEN : Number of times to write energies per ego file
      INTEGER    NUMEN
      PARAMETER  (BEGIN=32)
      LOGICAL    ERROR
      EXTERNAL TRIM, STRNUM
C
C =================================================
C read number of atoms, number of save coordinates
C =================================================
      WRITE(6,'(A)') ' READEG: read EGO header'
      READ(EGO,'(A80)',ERR=7777) DUMMY 
C   this reads the first line which is definetly a REMARK about the program version      
ccc        WRITE(6,'(A)',ERR=7777) DUMMY 
  500 IF (dummy(1:22) .ne. "REMARK Number of atoms") THEN
        READ(EGO,'(A80)',ERR=7777) DUMMY
ccc        WRITE(6,'(A)',ERR=7777) DUMMY 
        GOTO 500 
      END IF
      DLEN=LEN(DUMMY)
C Remove trailing blanks in string: TRIM
      CALL TRIM(DUMMY,DLEN)
      CALL STRNUM(DUMMY,23,DLEN,'INT',NATOM,DOUBLE,ERROR)
ccc         WRITE(6,'(A)',ERR=7777) 'dummy=',DUMMY(23:DLEN),dlen
      WRITE(6,'(A,I6)') ' READEG: NATOM = ', NATOM
      READ(EGO,'(A80)',ERR=7777) DUMMY 
      DLEN=LEN(DUMMY)
      CALL TRIM(DUMMY,DLEN)
      CALL STRNUM(DUMMY,20,DLEN,'INT',NSAVC,DOUBLE,ERROR)
      WRITE(6,'(A,I6)') ' READEG: NSAVC = ', NSAVC
      READ(EGO,'(A80)',ERR=7777) DUMMY 
C***  This was the restart intervall
C Lines added S. Crouzy jan. 3 1995
      READ(EGO,'(A80)',ERR=7777) DUMMY 
      DLEN=LEN(DUMMY)
      CALL TRIM(DUMMY,DLEN)
      IF (DUMMY(8:15).EQ.'Timestep') THEN
C  Old version of EGO
      NUMEN=NSAVC
      PLEN=DLEN
      GOTO  7412
      END IF
      CALL STRNUM(DUMMY,19,DLEN,'INT',NSAVE,DOUBLE,ERROR)
      WRITE(6,'(A,I6)') ' READEG: NSAVE = ', NSAVE
C***  This was how often energies are output
      NUMEN = NSAVC/NSAVE
C     write(6,*) 'NUMEN ',NUMEN
      READ(EGO,'(A80)',ERR=7777) DUMMY 
C***  This was the timestep used
      PLEN=LEN(DUMMY)
      CALL TRIM(DUMMY,PLEN)
 7412 CALL STRNUM(DUMMY,19,PLEN,'FLO',INT,DELTA,ERROR)
C
C-ERROR-LABEL
      GOTO 16
7777  WRITE(6,'(A)') ' %COOR-ERR: ERROR when reading head of EGO '
      error = .TRUE.
C ==============================
C read EGO coordinates 
C ==============================
16    WRITE(6,'(A)') ' READEG: read EGO coordinate set'
      DO 600 IATOM=1,NATOM
      READ(EGO,*,ERR=7800) X(IATOM),Y(IATOM),Z(IATOM)
  600 CONTINUE
      goto 7801
C error
7800  WRITE(6,'(A)') ' %COOR-ERR: error when reading coordinates'
      error = .TRUE.
7801  continue
C ====================
C read EGO energies
C ====================
      WRITE(6,'(A)') ' READEG: read EGO energies'
      DO 800 I=1,NUMEN
      DO 700 J=1,NLINFO
 7820 READ(EGO,'(A80)',ERR=8888) PLINFO(J)
C      WRITE(6,*) ' J ',J,PLINFO(J)
C     This skips the utilization display
      IF (PLINFO(J)(1:11) .EQ. 'REMARK LOAD') GOTO 7820
C
      PLEN=LEN(PLINFO(J))
      CALL TRIM(PLINFO(J),PLEN)
C     NLINFO-1 is the number of the integration step!      
      IF (J.EQ.NLINFO-1) THEN
        CALL STRNUM(PLINFO(J),BEGIN,BEGIN+21,'INT',NSTEP,DOUBLE,ERROR)
C       The integration step could be negative to mark invalid energies!
C       for later use (number of  sets  written to file)
        IF (I.EQ.1) ISTART=ABS(NSTEP)
C	this takes care of the integration step already read      
        ENERGY(J)=0.0
      ELSE
        CALL STRNUM(PLINFO(J),BEGIN,BEGIN+22,'FLO',INT,ENERGY(J),ERROR)
      END IF
C
  700 CONTINUE
C***  now let's write those energies!      
      WRITE(IUNENR,'(I9,A1,F10.3,2(A1,G20.9))',ERR=8000) 
     &	NSTEP,TAB,ENERGY(NLINFO),TAB,ENERGY(1),TAB,ENERGY(2)
C*** that was the integration step number, the time for this step, the estat, and the vdW energy     
      WRITE(IUNENR,'(G20.9,3(a1,G20.9))',ERR=8000) ENERGY(3), 
     &TAB,ENERGY(4),TAB,ENERGY(5),TAB,ENERGY(6)
C*** that was bonded, angle, dihedral, improper energies      
      WRITE(IUNENR,'(3(G20.9,a1),G20.9)',ERR=8000)
     &ENERGY(7),TAB,ENERGY(8),TAB,ENERGY(9),TAB,ENERGY(10)
      WRITE(IUNENR,'(G20.9,a1,G20.9)',ERR=8000)
     &ENERGY(11),TAB,ENERGY(12)
C*** that was constraint, sbound, hbond, kinetic, total energy and the temperature      
      goto 8001
C error
8000  WRITE(6,'(A)') ' %COOR-ERR: error when writing out.enr'
      error = .TRUE.
8001  continue
  800 CONTINUE
C
C-ERROR-LABEL
      GOTO 9999
8888  WRITE(6,'(A)') ' %COOR-ERR: ERROR when reading EGO energies'
      WRITE(6,*) ' J ',J,PLINFO(J)
      error = .TRUE.
9999  CONTINUE
C
      RETURN
      END
C
      SUBROUTINE NEXTVERS(FILE)
C
C Creates "version numbers" on CONVEX if a "NEW" file
C  is already there.
C  Input : filename  or filename_version
C  Output : filename_version+1
C
C +++++++++++++++++
C universal version
C +++++++++++++++++
C
C Michael Nilges, 21-MAY-87
C =========================
C
      IMPLICIT NONE
C input/output
      CHARACTER*(*) FILE
C local
      INTEGER I, FILLEN
      CHARACTER*10 NUMBERS
      CHARACTER*5 TEMP
      CHARACTER V
      INTEGER VERSION,NEWVERSION,VN
      INTEGER DECODI
      LOGICAL OK
      EXTERNAL TRIM, DECODI, ENCODI
C begin
      NUMBERS='1234567890'
      FILLEN=LEN(FILE)
      CALL TRIM(FILE,FILLEN)
C Find position of last "_"
      I=FILLEN
  900 IF ((I.GT.2).AND.(INDEX(NUMBERS,FILE(I:I)).GT.0)) THEN
        V=FILE(I:I)
        I=I-1
        GOTO 900
      END IF
C Create version number
      IF ((FILE(I:I).EQ.'_').AND.(INDEX(NUMBERS,V).GT.0)) THEN
        TEMP=FILE((I+1):FILLEN)
        VERSION=DECODI(TEMP,FILLEN-I,OK)
        NEWVERSION=VERSION + 1
        TEMP=' '
      IF (MOD(NEWVERSION,10).EQ.0) THEN
          CALL ENCODI(NEWVERSION,TEMP,FILLEN-I+1,VN)
          FILE((I+1):FILLEN+1)=TEMP
      ELSE
          CALL ENCODI(NEWVERSION,TEMP,FILLEN-I,VN)
          FILE((I+1):(FILLEN))=TEMP
      END IF
      ELSE
        FILE((FILLEN+1):(FILLEN+2))='_1'
      END IF
      RETURN
      END
C
C
C
      SUBROUTINE ENCODI(I,ST,STMAX,STLEN)
C
C Converts integer I into string ST.
C Restricted to maximum of 20 digits.
C
C By Axel Brunger, 23-MAY-86
C ==========================
C
      IMPLICIT NONE
C input/output
      INTEGER I
      CHARACTER*(*) ST
      INTEGER STMAX, STLEN
C local
      CHARACTER*20 TEMP
      INTEGER P
C begin
C
      ST=' '
C
C encode integer I using (right-justified) I20 format.
      WRITE(TEMP,'(I20)') I
C
C remove leading blanks
      P=1
17785 IF (P.LE.20.AND.TEMP(P:P).EQ.' ') THEN
      P=P+1
      GOTO 17785
      ENDIF
      STLEN=20-P+1
      IF (STMAX.LT.STLEN) THEN
      WRITE(6,'(A)') ' %ENCODI-ERR: check STMAX'
      ELSE
      ST(1:STLEN)=TEMP(P:20)
      END IF
      RETURN
      END
C
      INTEGER FUNCTION DECODI(ST,STLEN,OK)
C
C Converts the string into an integer, if conversion not
C successful OK=.FALSE.
C Restricted to an input field with a maximum of 20 characters.
C
C Axel Brunger, 10-DEC-83
C =======================
C
      IMPLICIT NONE
C input/output
      CHARACTER*(*) ST
      INTEGER STLEN
      LOGICAL OK
C local
      INTEGER I
      CHARACTER*20 TEMP
C
C begin
      OK=.TRUE.
      TEMP=' '
C
C right-justify the integer in the 20 character string TEMP
      TEMP(20-STLEN+1:20)=ST(1:STLEN)
C
      READ(TEMP,'(I20)',ERR=9999) I
      DECODI=I
C
      GOTO 8888
9999  OK=.FALSE.
      DECODI=0
8888  CONTINUE
      RETURN
      END
C
      REAL FUNCTION DECODF(ST,STLEN,OK)
C
C Converts the string into an float, if conversion not
C successful OK=.FALSE.
C Restricted to an input field with a maximum of 30 characters.
C
C Axel Brunger, 10-DEC-83
C =======================
C
      IMPLICIT NONE
C input/output
      CHARACTER*(*) ST
      INTEGER STLEN
      LOGICAL OK
C local
      REAL I
      CHARACTER*30 TEMP
C
C begin
      OK=.TRUE.
      TEMP=' '
C
C right-justify the integer in the 30 character string TEMP
      TEMP(30-STLEN+1:30)=ST(1:STLEN)
C
      READ(TEMP,'(D30.20)',ERR=9999) I
      DECODF=I
C
      GOTO 8888
9999  OK=.FALSE.
      DECODF=0
8888  CONTINUE
      RETURN
      END
C
      SUBROUTINE WRTIT(UNIT,IOP)
C
C This routine is a primitive version of SUBROUTONE WRTITLE
C in util.s
C The date and username will be added at the end, the
C filename will be added at the beginning of the title.
C
C
      IMPLICIT NONE
C input/output
      INTEGER UNIT, IOP
C titles
      INTEGER NTITLE,MXTITL,TITMAX
      PARAMETER (MXTITL=32,TITMAX=80)
      CHARACTER*(TITMAX) TITLE(MXTITL)
C local
      LOGICAL ERROR
      INTEGER J
C begin
      NTITLE=1
C
C put in filename
      TITLE(NTITLE)=' REMARKS FILENAME= *.ego '
      NTITLE=NTITLE+1
C
C put in date and username
      TITLE(NTITLE)=' REMARKS DATE: ?/?/??   created by user: ALTER'
C
      IF ((-1).EQ.(IOP)) THEN
C
C for binary output
      WRITE(UNIT,ERR=9) NTITLE,(TITLE(J),J=1,NTITLE)
      ELSE 
      WRITE(6,'(A)') ' %WRTIT-ERR: UNIT not binary'
      END IF
C-error-labels----
      GOTO 99
9     ERROR=.TRUE.
      WRITE(6,'(A)') ' %WRTIT-ERR: ERROR DURING WRITE'
99    CONTINUE
C-----------------
      RETURN
      END
C
      SUBROUTINE STRNUM(ST,START,STLEN,FLAG,RESINT,RESFLO,ERROR)
C 
C this subroutine converts the string ST to an double precision RESFLO
C or an integer RESINT
C FLAG is a flag whether number in ST is a INTeger or a FLOating point number
C
C input/output
      INTEGER           START, STLEN, RESINT
      DOUBLE PRECISION  RESFLO
      CHARACTER*(*)     ST, FLAG
C local
      LOGICAL       ERROR,OK
C
      INTEGER STSTA
C
      INTEGER DECODI
      REAL DECODF
      EXTERNAL DECODI, DECODF
C
      STSTA = START
C First we trim away any leading blanks
  10  CONTINUE
      IF (((STLEN - STSTA).GT.0).AND.
     @   (ST(STSTA:STSTA).EQ.' ')) THEN
        STSTA=STSTA+1
        GOTO 10
      END IF
ccc        write(6,*)STSTA,STLEN,st,st(STSTA:STLEN)
C
      IF(FLAG(1:3).EQ.'INT') THEN
      RESINT = DECODI(ST(STSTA:STLEN),STLEN-STSTA+1,OK)
      IF (.NOT.OK) GOTO 7777
      RESFLO=0.0
      ELSE IF(FLAG.EQ.'FLO') THEN
      RESFLO = DECODF(ST(STSTA:STLEN),STLEN-STSTA+1,OK)
      IF (.NOT.OK) GOTO 7777
      RESINT=0
      ELSE
      WRITE(6,'(A)') ' %STRNUM-ERR: no matching flag'
      END IF
      goto 8888
7777  ERROR=.TRUE.
      WRITE(6,'(A)') ' %STRNUM-ERR: error when converting'
      WRITE(6,'(A)') ST(STSTA:STLEN)
8888  continue
      RETURN
      END
