/*
#    Molecular Dynamics program EGO
#    Copyright (C) 1989  Markus Eichinger, Helmut Grubmueller, and Helmut Heller
#
#    official EGO web site: http://www.lrz.de/~heller/ego/
#
#    Contact the authors here:
#    Dr. Markus Eichinger:   entwicklung@eichinger-net.de
#    Dr. Helmut Grubmueller: hgrubmu@gwdg.de
#    Dr. Helmut Heller:      heller@lrz.de
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#    For the full text of the license, see file LICENSE
#
#########################################################################
*/

#define VERSION "EGO_VIII.22"
/***********************************************************************
4  -->  5	: MPI added, wodata improved.
5  -->  6	: Malloc bug in egmarti.c fixed, SP2-error packing,
		  First file after restart must be written --- bug fixed.
6  -->  7	: MPI works now on Dec's and SP2 (MPI_Ssend).
		  COM, P and L calcualted each analysis step.
		  All atom data are now distributed to the nodes.
7  -->  8	: Sequentiell version of EGO runs now. Some small
		  changes concerning allocation on nodes. Bug fixed
		  concerning old output style "double integration step #"
		  MPI runs now with overlapping communication on Decs.
8  -->  9	: Multi-dihedrals + small improvements for clustering small
		  systems.
9  --> 10	: Unitsdefinition by units.def file.
10 --> 11	: Makefile SEQ better. eganaly restart-file NEXT problem
		  fixed. Seq Version small bug (initialization coord-packet)
		  fixed. xpl2lis Unitsdef EOF Bug fixed.
		  Outputfile prints now Machinetype and PVM_ARCH. 
11 --> 12 	: Bug in in_edge() function for round corners/edges.
		  Bug in the sequential version after reclustering.
		  Small Bugs in xpl2lis concerning Unitsdef.
		  Old, but not new koords now sent in egmach.c to master.
12 --> 13	: Alloc Bug in egrotflood.c (occured if last atom in list
		  is not flooded/rotcorrected).
13 --> 14	: restart now realy works fine (Seq/Par).
		  Alloc Bug in egtree.c in case of very small molecules.
		  Some Makefile-changes. Dihedral-Bug (N-128 for default)
		  fixed. 
14 --> 15	: EGO uses now the numerical recipies random generator.
		  aimk for sequential version impruved (no pvm needed).
		  Reclustering is prevented between restart writing.
15 --> 16	: Shake convergence criterion was to hard --> fixed.
		  ego2crd improved (Xplor/Charm-Quanta flag).
		  Comments in source code improved. Atom- and Resiude-Strings
		  now 0 terminated. ctl.lis with cylindric parameters and
		  more flooding parameters. User-defined parameters.
		  Changed coord.lis format (single line per atom!) which is
		  is more easier to parse. add_water included to maketaz.
16 --> 17	: xpl2lis (units.def) parses now atomstrings with '*' ==>
		  wildcard-string compare works now with escape '/' for wildc.
		  In units.def now DNA defined. A small bug in unit-definition
		  was fixed by C. Brandt.
		  Nearly all forces on selected atoms can be written to file.
17 --> 18	: Alloc Bug in egcontro.c fixed, occured in case of force
		  writing out.
		  Pulling now possible!
		  PVM-synchronisation bug fixed (occured in case of no Equilibr,
		  --> often DeadLocks for small molecules).
18 --> 18.1	: CTLFILE structure eliminated.
		  Now only this memory is allocated which is realy needed
		  to store the forces on the master.
		  In ego.h all structures PARIX-Aligned.
		  All PICK statements work now.
18.1 ---> 19	: All things tested. Small changes concerning output-format.
19   ---> 19.1  : Introduced constant pressure mode.
		  Output of pressure on the SBound-surfaces.
19.1  ---> 19.2 : Reduced alloc memory on the master node significantly
		  (bondlist reduced,start_msg/no_nodes,struct_cluster_reduced).
		  xpl2lis works now with the "prime-character" ' in the 
		  atom-name.	
19.2. ---> 19.3 : Constant SBound-density mode. Free Energy-calculation now
		  possible. Reduced realloc after reclustering on the nodes.
		  Improved clustering in egclust.c and egmarti.c to obtain
		  better load-balancing.
		  Added Langevin dynamics to pistons for constant pressure mode.
19.3 ----> 19.4 : Much work on QM-interface. Selection string works now also
                  with distance-criterions. Kinetik enregy of the COM is printed to
		  screen in kcal/mol.
19.4 ----> 19.5 : Added 2 parameters for constant density/pressure mode
		  in ctl.lis file:
		  now we have X, Y, Z pressures/densities specified differently.
		  Added that constant pressure mode does not affect planes with
		  pressure = 0.0 atm. Now we can specify things like
		  constant normal pressure and constant surface area!
19.5 -----> 19.6  Some things for QM-interface. Separate neutral clustering
                  via ctl.lis file possible.
19.6 -----> 19.7  Many things improved (also comments). EGO works now
                  also on the Parsytec CC machine. Force output prints out
                  also coordinates. Signals can be sent to EGO in order make
                  a soft stop.             
19.7 -----> 19.8  More things for the QM interface (better handling of stop cases).
                  in egmepvm.c now a checksum can be compiled. Virial-stuff. 
19.8 -----> 20.0  Much things improved for QM-stuff. First version of Kossis
                  SBound. First version of Grubis Sbound.s
20.0 -----> 20.1  Many things improved for QM-stuff. Much work on the Sbound and
                  also on the arbitrary SBound. Extern dynamic. Makefile for DOS
                  WIN95/WIN NT. Improvement of xpl2lis.
20.1 -----> 20.2  Added the torque force from Kossi's thesis on the SBOUND atoms. HH.
20.2 -----> 20.3  VPP eingefvhrt. HH.
20.3 -----> 20.3p1As a test I reduced the lipid SBOUND2 force by 1/2 in ego.h. HH.
21                The final version at the end of Markus Eichingers thesis.
22		  Port to Mac OS X
***********************************************************************/
