/*
#    Molecular Dynamics program EGO
#    Copyright (C) 1989  Markus Eichinger, Helmut Grubmueller, and Helmut Heller
#
#    official EGO web site: http://www.lrz.de/~heller/ego/
#
#    Contact the authors here:
#    Dr. Markus Eichinger:   entwicklung@eichinger-net.de
#    Dr. Helmut Grubmueller: hgrubmu@gwdg.de
#    Dr. Helmut Heller:      heller@lrz.de
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#    For the full text of the license, see file LICENSE
#
#########################################################################
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#if defined(NEXT) || defined(RS6K) || defined(MAC)
#include <stdlib.h>
#elif defined(PARIX) || defined(PARIXPPC)
#include <sys/memory.h>
#elif defined(PARIXHAL)
#include </export/epx/epx/include/epx/memory.h>
#else
#include <malloc.h>
#endif

void  *malloc (size_t size);
void  *realloc (void* ptr, size_t size);
void   free (void *ptr);

STRUCT_ATOMDATA *alloc_atomdata (int len);
int   *alloc_ints(int len);
int   **alloc_ptrs(int len);
double *alloc_doubles (int len);
float *alloc_floats (int len);
void   myfree (void *ptr);

